#define IEM_GUI_COLOR_WHITE          "white"
#define IEM_GUI_COLOR_LL_GREY        "grey88"
#define IEM_GUI_COLOR_L_GREY         "grey75"
#define IEM_GUI_COLOR_ML_GREY        "grey63"
#define IEM_GUI_COLOR_M_GREY         "grey50"
#define IEM_GUI_COLOR_MD_GREY        "grey38"
#define IEM_GUI_COLOR_D_GREY         "grey25"
#define IEM_GUI_COLOR_DD_GREY        "grey13"
#define IEM_GUI_COLOR_BLACK          "black"
#define IEM_GUI_COLOR_L_RED          "rosybrown1"
#define IEM_GUI_COLOR_RED            "red1"
#define IEM_GUI_COLOR_D_RED          "red4"
#define IEM_GUI_COLOR_L_ORANGE       "lightgoldenrod1"
#define IEM_GUI_COLOR_ORANGE         "orange1"
#define IEM_GUI_COLOR_D_ORANGE       "sienna4"
#define IEM_GUI_COLOR_L_YELLOW       "lemonchiffon1"
#define IEM_GUI_COLOR_YELLOW         "yellow1"
#define IEM_GUI_COLOR_D_YELLOW       "sienna1"
#define IEM_GUI_COLOR_L_GREEN        "darkseagreen2"
#define IEM_GUI_COLOR_GREEN          "green2"
#define IEM_GUI_COLOR_D_GREEN        "darkgreen"
#define IEM_GUI_COLOR_L_CYAN         "paleturquoise1"
#define IEM_GUI_COLOR_CYAN           "cyan1"
#define IEM_GUI_COLOR_D_CYAN         "turquoise4"
#define IEM_GUI_COLOR_L_BLUE         "skyblue1"
#define IEM_GUI_COLOR_BLUE           "blue1"
#define IEM_GUI_COLOR_D_BLUE         "blue4"
#define IEM_GUI_COLOR_L_MAGENTA      "plum1"
#define IEM_GUI_COLOR_MAGENTA        "magenta1"
#define IEM_GUI_COLOR_D_MAGENTA      "magenta4"

#define IEM_GUI_COLNR_WHITE          0
#define IEM_GUI_COLNR_ML_GREY        1
#define IEM_GUI_COLNR_D_GREY         2
#define IEM_GUI_COLNR_L_RED          3
#define IEM_GUI_COLNR_L_ORANGE       4
#define IEM_GUI_COLNR_L_YELLOW       5
#define IEM_GUI_COLNR_L_GREEN        6
#define IEM_GUI_COLNR_L_CYAN         7
#define IEM_GUI_COLNR_L_BLUE         8
#define IEM_GUI_COLNR_L_MAGENTA      9

#define IEM_GUI_COLNR_LL_GREY        10
#define IEM_GUI_COLNR_M_GREY         11
#define IEM_GUI_COLNR_DD_GREY        12
#define IEM_GUI_COLNR_RED            13
#define IEM_GUI_COLNR_ORANGE         14
#define IEM_GUI_COLNR_YELLOW         15
#define IEM_GUI_COLNR_GREEN          16
#define IEM_GUI_COLNR_CYAN           17
#define IEM_GUI_COLNR_BLUE           18
#define IEM_GUI_COLNR_MAGENTA        19

#define IEM_GUI_COLNR_L_GREY         20
#define IEM_GUI_COLNR_MD_GREY        21
#define IEM_GUI_COLNR_BLACK          22
#define IEM_GUI_COLNR_D_RED          23
#define IEM_GUI_COLNR_D_ORANGE       24
#define IEM_GUI_COLNR_D_YELLOW       25
#define IEM_GUI_COLNR_D_GREEN        26
#define IEM_GUI_COLNR_D_CYAN         27
#define IEM_GUI_COLNR_D_BLUE         28
#define IEM_GUI_COLNR_D_MAGENTA      29

#define IEM_GUI_COLOR_SELECTED       "blue"
#define IEM_GUI_COLOR_NORMAL         "black"

#define IEM_GUI_MAX_COLOR            30

#define IEM_GUI_DEFAULTSIZE 15
#define IEM_GUI_MINSIZE 8
#define IEM_GUI_MAXSIZE 1000
#define IEM_SL_DEFAULTSIZE 128
#define IEM_SL_MINSIZE 20

#define IEM_BNG_DEFAULTHOLDFLASHTIME 250
#define IEM_BNG_DEFAULTBREAKFLASHTIME 50
#define IEM_BNG_MINHOLDFLASHTIME 50
#define IEM_BNG_MINBREAKFLASHTIME 10

#define IEM_VU_DEFAULTSIZE 3
#define IEM_VU_LARGESMALL  2
#define IEM_VU_MINSIZE     2
#define IEM_VU_MAXSIZE     25
#define IEM_VU_STEPS       40

#define IEM_VU_MINDB    -99.9
#define IEM_VU_MAXDB    12.0
#define IEM_VU_OFFSET   100.0

t_symbol *iem_gui_key_sym=0;

char *iem_gui_color_str[]=
{
    IEM_GUI_COLOR_WHITE,
    IEM_GUI_COLOR_ML_GREY,
    IEM_GUI_COLOR_D_GREY,
    IEM_GUI_COLOR_L_RED,
    IEM_GUI_COLOR_L_ORANGE,
    IEM_GUI_COLOR_L_YELLOW,
    IEM_GUI_COLOR_L_GREEN,
    IEM_GUI_COLOR_L_CYAN,
    IEM_GUI_COLOR_L_BLUE,
    IEM_GUI_COLOR_L_MAGENTA,

    IEM_GUI_COLOR_LL_GREY,
    IEM_GUI_COLOR_M_GREY,
    IEM_GUI_COLOR_DD_GREY,
    IEM_GUI_COLOR_RED,
    IEM_GUI_COLOR_ORANGE,
    IEM_GUI_COLOR_YELLOW,
    IEM_GUI_COLOR_GREEN,
    IEM_GUI_COLOR_CYAN,
    IEM_GUI_COLOR_BLUE,
    IEM_GUI_COLOR_MAGENTA,

    IEM_GUI_COLOR_L_GREY,
    IEM_GUI_COLOR_MD_GREY,
    IEM_GUI_COLOR_BLACK,
    IEM_GUI_COLOR_D_RED,
    IEM_GUI_COLOR_D_ORANGE,
    IEM_GUI_COLOR_D_YELLOW,
    IEM_GUI_COLOR_D_GREEN,
    IEM_GUI_COLOR_D_CYAN,
    IEM_GUI_COLOR_D_BLUE,
    IEM_GUI_COLOR_D_MAGENTA
};

char *iem_gui_info_color_str[]=
{
    "white",
    "medium_light_grey",
    "dark_grey",
    "light_red",
    "light_orange",
    "light_yellow",
    "light_green",
    "light_cyan",
    "light_blue",
    "light_magenta",
    "very_light_grey",
    "medium_grey",
    "very_dark_grey",
    "red",
    "orange",
    "yellow",
    "green",
    "cyan",
    "blue",
    "magenta",
    "light_grey",
    "medium_dark_grey",
    "black",
    "dark_red",
    "dark_orange",
    "dark_yellow",
    "dark_green",
    "dark_cyan",
    "dark_blue",
    "dark_magenta"
};

/*
led1 : -99.5 .. -80 db   = -60 db b;
led2 : -79.5 .. -60 db   = -60 db g;
led3 : -59.5 .. -55 db   = -50 db g -50;
led4 : -54.5 .. -50 db   = -50 db g -50;
led5 : -49.5 .. -45 db   = -40 db g;
led6 : -44.5 .. -40 db   = -40 db g;
led7 : -39.5 .. -35 db   = -30 db g -30;
led8 : -34.5 .. -30 db   = -30 db g -30;
led9 : -29.5 .. -27.5 db = -25 db g;
led10: -27   .. -25 db   = -25 db g;
led11: -24.5 .. -22.5 db = -20 db g -20;
led12: -22   .. -20 db   = -20 db g -20;
led13: -19.5 .. -18 db   = -16 db g;
led14: -17.5 .. -16 db   = -16 db g;
led15: -15.5 .. -14 db   = -12 db g -12;
led16: -13.5 .. -12 db   = -12 db g -12;
led17: -11.5 .. -10.5 db = - 9 db y;
led18: -10   .. - 9 db   = - 9 db y;
led19: - 8.5 .. - 7.5 db = - 6 db y -6;
led20: - 7   .. - 6 db   = - 6 db y -6;
led21: - 5.5 .. - 5 db   = - 4 db y;
led22: - 4.5 .. - 4 db   = - 4 db y;
led23: - 3.5 .. - 3 db   = - 2 db y -2;
led24: - 2.5 .. - 2 db   = - 2 db y -2;
led25: - 1.5 .. - 1.5 dB = - 1 db y;
led26: - 1   .. - 1 dB   = - 1 db y;
led27: - 0.5 .. - 0.5 db = - 0 db o -0;
led28: - 0   .. - 0 db   = - 0 db o -0;
led29: + 0.5 .. + 0.5 db = + 1 db r;
led30: + 1   .. + 1 db   = + 1 db r;
led31: + 1.5 .. + 1.5 db = + 2 db r +2;
led32: + 2   .. + 2 db   = + 2 db r +2;
led33: + 2.5 .. + 3 db   = + 4 db r;
led34: + 3.5 .. + 4 db   = + 4 db r;
led35: + 4.5 .. + 5 db   = + 6 db r +6;
led36: + 5.5 .. + 6 db   = + 6 db r +6;
led37: + 6.5 .. + 7.5 db = + 9 db r;
led38: + 8   .. + 9 db   = + 9 db r;
led39: + 9.5 .. +10.5 db = +12 db m;
led40: +11   .. +99 db   = +12 db m ++;
*/

int iem_gui_vu_db2i[]=
{
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
     6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
     7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
     8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
     9, 9, 9, 9, 9,10,10,10,10,10,
    11,11,11,11,11,12,12,12,12,12,
    13,13,13,13,14,14,14,14,15,15,
    15,15,16,16,16,16,17,17,17,18,
    18,18,19,19,19,20,20,20,21,21,
    22,22,23,23,24,24,25,26,27,28,
    29,30,31,32,33,33,34,34,35,35,
    36,36,37,37,37,38,38,38,39,39,
    39,40,40,40,40,40
};

int iem_gui_vu_col[]=
{
    0,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
    15,15,15,15,15,15,15,15,15,15,14,14,13,13,13,13,13,13,13,13,13,13,13,19,19,19
};
/*int iem_gui_vu1_db2i[]=
{
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
     3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
     3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
     3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4,

     5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
     6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
     7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
     8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
     9, 9, 9, 9, 9,10,10,10,10,10,
    11,11,11,11,11,12,12,12,12,12,
    13,13,13,13,14,14,14,14,15,15,
    15,15,16,16,16,16,17,17,17,18,
    18,18,19,19,19,20,20,20,21,21,
    22,22,23,23,24,24,25,26,27,28,
    29,30,31,32,33,33,34,34,35,35,
    36,36,37,37,37,38,38,38,39,39,
    39,40,40,40,40,40
};*/

/*
 led1 : -99.5  .. -89.5 db  = 40 g;
 led2 : -89.5  .. -79.5 db  = 40 g;
 led3 : -79.5  .. -69.5 db  = 40 g;
 led4 : -69.5  .. -64.5 db  = 20 g;
 led5 : -64.5  .. -59.5 db  = 20 g;
 led6 : -59.5  .. -54.5 db  = 20 g;
 led7 : -54.5  .. -52 db    = 10 g;
 led8 : -52    .. -49.5 db  = 10 g -50;
 led9 : -49.5  .. -47 db    = 10 g;
 led10: -47    .. -44.5 db  = 10 g;
 led11: -44.5  .. -42 db    = 10 g;
 led12: -42    .. -39.5 db  = 10 g;
 led13: -39.5  .. -37 db    = 10 g;
 led14: -37    .. -34.5 db  = 10 g;
 led15: -34.5  .. -32.25 db = 9 g;
 led16: -32.25 .. -30.25 db = 8 g -30;
 led17: -30.25 .. -28.5 db  = 7 g;
 led18: -28.5  .. -27 db    = 6 g;
 led19: -27    .. -25.75 db = 5 g;
 led20: -25.75 .. -24.5 db  = 5 g;?????????????????
 led21: -24.5  .. -23.25 db = -20 db g;
 led22: -23.25 .. -22 db    = -20 db g;
 led23: -22    .. -20.75 db = -20 db g;
 led24: -20.75 .. -19.5 db  = -20 db g -20;
 led25: -19.5  .. -18.5 db  = -16 db g;
 led26: -18.5  .. -17.5 db  = -16 db g;
 led27: -17.5  .. -16.5 db  = -16 db g;
 led28: -16.5  .. -15.5 db  = -16 db g;
 led29: -15.5  .. -14.5 db  = -12 db g;
 led30: -14.5  .. -13.5 db  = -12 db g;
 led31: -13.5  .. -12.5 db  = -12 db g;
 led32: -12.5  .. -11.5 db  = -12 db y -12;
 led33: -11.5  .. -10.75 db = - 9 db y;
 led34: -10.75 .. -10 db    = - 9 db y;
 led35: -10    .. - 9.25 db = - 9 db y;
 led36: - 9.25 .. - 8.5 db  = - 9 db y;
 led37: - 8.5  .. - 7.75 db = - 6 db y;
 led38: - 7.75 .. - 7 db    = - 6 db y;
 led39: - 7    .. - 6.25 db = - 6 db y;
 led40: - 6.25 .. - 5.5 db  = - 6 db y -6;
 led41: - 5.5  .. - 5 db    = - 4 db y;
 led42: - 5    .. - 4.5 db  = - 4 db y;
 led43: - 4.5  .. - 4 db    = - 4 db y;
 led44: - 4    .. - 3.5 db  = - 4 db y;
 led45: - 3.5  .. - 3 db    = - 2 db y;
 led46: - 3    .. - 2.5 db  = - 2 db y;
 led47: - 2.5  .. - 2 db    = - 2 db y -2;
 led48: - 2    .. - 1.5 db  = - 2 db y;
 led49: - 1.5  .. - 1.25 dB = - 1 db y;
 led50: - 1.25 .. - 1 dB    = - 1 db y;
 led51: - 1    .. - 0.75 dB = - 1 db y;
 led52: - 0.75 .. - 0.5 dB  = - 1 db y;
 led53: - 0.5  .. - 0.25 db = - 0 db y;
 led54: - 0.25 .. - 0 db    = - 0 db y;
 led55: - 0    .. - 0 db    = - 0 db r -0;
 led56: - 0    .. + 0.25 db = - 0 db r;
 led57: + 0.25 .. + 0.5 db  = + 1 db r;
 led58: + 0.5  .. + 0.75 db = + 1 db r;
 led59: + 0.75 .. + 1 db    = + 1 db r;
 led60: + 1    .. + 1.25 db = + 1 db r;
 led61: + 1.25 .. + 1.5 db  = + 2 db r;
 led62: + 1.5  .. + 1.75 db = + 2 db r;
 led63: + 1.75 .. + 2 db    = + 2 db r +2;
 led64: + 2    .. + 2.25 db = + 2 db r;
 led65: + 2.25 .. + 2.5 db  = + 4 db r;
 led66: + 2.5  .. + 3 db    = + 4 db r;
 led67: + 3    .. + 3.5 db  = + 4 db r;
 led68: + 3.5  .. + 4 db    = + 4 db r;
 led69: + 4    .. + 4.5 db  = + 6 db r;
 led70: + 4.5  .. + 5 db    = + 6 db r;
 led71: + 5    .. + 5.5 db  = + 6 db r;
 led72: + 5.5  .. + 6 db    = + 6 db r +6;
 led73: + 6    .. + 6.75 db = + 9 db r;
 led74: + 6.75 .. + 7.5 db  = + 9 db r;
 led75: + 7.5  .. + 8.25 db = + 9 db r;
 led76: + 8.25 .. + 9 db    = + 9 db r;
 led77: + 9    .. + 9.75 db = +12 db r;
 led78: + 9.75 .. +10.5 db  = +12 db r;
 led79: +10.5  .. +11.25 db = +12 db r;
 led80: +11.25 .. +99 db    = +12 db r ++;
*/

/*int iem_gui_vu_col[]=
{
    0,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
    15,15,15,15,15,15,15,15,15,15,14,14,13,13,13,13,13,13,13,13,13,13,13,19,19,19
};*/

char *iem_gui_vu_scale_str[]=
{
    "",
    "<-99",
    "",
    "",
    "",
    "-50",
    "",
    "",
    "",
    "-30",
    "",
    "",
    "",
    "-20",
    "",
    "",
    "",
    "-12",
    "",
    "",
    "",
    "-6",
    "",
    "",
    "",
    "-2",
    "",
    "",
    "",
    "-0dB",
    "",
    "",
    "",
    "+2",
    "",
    "",
    "",
    "+6",
    "",
    "",
    "",
    ">+11",
    "",
    "",
    "",
    "",
    "",
};

int iem_gui_clip_size(int size)
{
    if(size < IEM_GUI_MINSIZE)
	size = IEM_GUI_MINSIZE;
    return(size);
}

int iem_gui_modulo_color(int col)
{
    while(col >= IEM_GUI_MAX_COLOR)
	col -= IEM_GUI_MAX_COLOR;
    while(col < 0)
	col += IEM_GUI_MAX_COLOR;
    return(col);
}

/*new-beg*/
void str_xch_raute2dollar(t_symbol *s)
{
    if(s->s_name[0] == '#')
	s->s_name[0] = '$';
}

void str_xch_dollar2raute(t_symbol *s)
{
    if(s->s_name[0] == '$')
	s->s_name[0] = '#';
}
/*new-end*/
